Attribute VB_Name = "Module1"

Declare Function GetTickCount Lib "kernel32" () As Long
Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Public Const SRCAND = &H8800C6  ' (DWORD) dest = source AND dest
Public Const SRCINVERT = &H660046       ' (DWORD) dest = source XOR dest

Type Player
x As Long
y As Long
TurnY As Long
Speed As Long
Damage As Long
Score As Long
Reload As Long

Mechanic As Long
DumbTank As Long

Cheater As Boolean

CheatCount As Long
End Type

Type Shot
x As Long
y As Long
Damage As Long
Act As Long
VSpeed As Long
AirF As Long
Speed As Long
End Type

Type Tank
x As Long
y As Long
Speed As Long
Act As Boolean
Reload As Long
End Type

Type Explosion
x As Long
y As Long
Count As Long
XF As Long
Act As Long
End Type

Type Boss
Damage As Long
x As Long
y As Long
Act As Long
Speed As Long
End Type

Public P As Player
Public PShot(20) As Shot

Public T(15) As Tank
Public TShot(20) As Shot

Public Explo(10) As Explosion

Public B As Boss
Public BShot(10) As Shot

Public Running As Boolean
Public PMask As Long, BMask As Long, TMask As Long, SMask As Long, BossM As Long
Public PAUSE As Long
Public MESSAGE As String
Public MSGSIZE As Long
Public REQSCORE As Long
Public LEVEL As Long

Public Sub Friction(Who As Player)
Select Case Who.Speed
Case Is < 0
Who.Speed = Who.Speed + 1
Case Is > 0
Who.Speed = Who.Speed - 1
End Select
End Sub

Public Sub MovePlayer(Who As Player)
Friction Who
Who.x = Who.x + Who.Speed
If Who.x < -32 Then Who.x = FrmGame.Board.ScaleWidth - 1
If Who.x > FrmGame.Board.ScaleWidth Then Who.x = -31
End Sub

Public Sub MoveShots()
Dim C As Long
For C = 0 To 20
If TShot(C).Act = True Then
TShot(C).y = TShot(C).y - TShot(C).Speed
If TShot(C).y < 0 Then TShot(C).Act = False
End If

If PShot(C).Act = True Then
PShot(C).y = PShot(C).y + 2
PShot(C).x = PShot(C).x + PShot(C).VSpeed

If PShot(C).AirF >= 4 Then
Select Case PShot(C).VSpeed
Case Is < 0
PShot(C).VSpeed = PShot(C).VSpeed + 1
Case Is > 0
PShot(C).VSpeed = PShot(C).VSpeed - 1
End Select
PShot(C).AirF = 0
Else
PShot(C).AirF = PShot(C).AirF + 1
End If

If PShot(C).y > FrmGame.Board.ScaleHeight + 2 Then
PShot(C).Act = False
End If
End If
Next C

For C = 0 To 10
If BShot(C).Act = True Then
BShot(C).y = BShot(C).y - BShot(C).Speed
If BShot(C).y < 0 Then BShot(C).Act = False
End If
Next C
End Sub

Public Function PHit(P As Player) As Boolean
PHit = False
Dim C As Long
For C = 0 To 20
If TShot(C).Act = True Then
If CollisionDetect(TShot(C).x, TShot(C).y, 5, 5, 0, 0, SMask, P.x, P.y, 32, 32, 0, P.TurnY, PMask) = True Then
TakeScore (5)
PHit = True
TShot(C).Act = False
DoExplode TShot(C).x, TShot(C).y
P.Damage = P.Damage + TShot(C).Damage
If P.Damage >= 100 Then Running = False
End If
End If
Next C

For C = 0 To 10
If BShot(C).Act = True Then
If CollisionDetect(BShot(C).x, BShot(C).y, 5, 5, 0, 0, SMask, P.x, P.y, 32, 32, 0, P.TurnY, PMask) = True Then
BShot(C).Act = False
DoExplode BShot(C).x + 2, BShot(C).y + 2
P.Damage = P.Damage + BShot(C).Damage
TakeScore (20)
If P.Damage >= 100 Then Running = False
End If
End If
Next C
End Function

Public Sub TankAI()
If P.DumbTank = True Then Exit Sub
Dim C As Long, C2 As Long
For C = 0 To 15
If T(C).Act = True Then
If T(C).x < P.x + 26 And T(C).x > P.x - 26 Then 'only fire if inside the player's range
If Int(Rnd * 5) = 3 Then TankFire (C) 'fire
End If
End If

For C2 = 0 To 20 'dodge the bullets (out of the player's range ai because you could drop a bomb and then leave)
If PShot(C).Act = True Then
If PShot(C).x > (T(C).x + 10) - 30 And PShot(C).x < (T(C).x + 10) + 30 And PShot(C).y > T(C).y - 30 Then
If PShot(C).x < (T(C).x + 10) Then T(C).Speed = 2
If PShot(C).x > (T(C).x + 10) Then T(C).Speed = -2
End If
End If
Next C2

If Int(Rnd * 10) = 7 Then 'speed up
Select Case T(C).Speed
Case Is < 0
T(C).Speed = T(C).Speed - 1
Case Is > 0
T(C).Speed = T(C).Speed + 1
End Select
End If

If Int(Rnd * 10) = 3 Then 'slow down
Select Case T(C).Speed
Case Is < 0
T(C).Speed = T(C).Speed + 1
If T(C).Speed = 0 Then T(C).Speed = -1
Case Is > 0
T(C).Speed = T(C).Speed - 1
If T(C).Speed = 0 Then T(C).Speed = 1
End Select
End If
Next C
End Sub

Public Sub TankFire(Tid As Long)
Dim C As Long
If T(Tid).Act = True Then
If T(Tid).Reload <= 0 Then
For C = 0 To 20
If TShot(C).Act = False Then
TShot(C).x = T(Tid).x + 10
TShot(C).y = T(Tid).y
TShot(C).Speed = 2 + Int(Rnd * (LEVEL)) + 1
TShot(C).Damage = Int(Rnd * (LEVEL)) + 1
T(Tid).Reload = 5
TShot(C).Act = True
Exit For
End If
Next C
End If
End If
End Sub

Public Sub Fire()
If P.Reload <= 0 Then
P.Reload = 4
Dim C As Long
For C = 0 To 20
If PShot(C).Act = False Then
PShot(C).Act = True
PShot(C).x = P.x + 32 \ 2
PShot(C).y = P.y + 32
PShot(C).VSpeed = P.Speed \ 2
Exit For
End If
Next C
End If
End Sub

Public Sub MoveTanks()
Dim C As Long, C2 As Long
For C = 0 To 10
If T(C).Act = True Then
T(C).Reload = T(C).Reload - 1: If T(C).Reload < 0 Then T(C).Reload = 0
T(C).x = T(C).x + T(C).Speed
If T(C).x - 20 < -20 Then T(C).Act = False
If T(C).x + 20 > FrmGame.Board.ScaleWidth + 20 Then T(C).Act = False
For C2 = 0 To 20
If PShot(C2).Act = True Then
If CollisionDetect(T(C).x, T(C).y, 20, 15, 0, 0, TMask, PShot(C2).x, PShot(C2).y, 5, 5, 0, 0, BMask) = True Then
T(C).Act = False
PShot(C2).Act = False
P.Score = P.Score + 10
DoExplode PShot(C2).x + 7, PShot(C2).y + 10
End If
End If
Next C2
End If
Next C

If B.Act = True Then
B.x = B.x + B.Speed
If B.x > FrmGame.Board.ScaleWidth Then B.x = -15
If B.x < -20 Then B.x = FrmGame.Board.ScaleWidth - 19
For C = 0 To 20
If PShot(C).Act = True Then
If CollisionDetect(PShot(C).x, PShot(C).y, 10, 15, 0, 0, SMask, B.x, B.y, 40, 30, 0, 0, BossM) = True Then
B.Damage = B.Damage + 5
If B.Damage > 100 Then
Dim C5 As Long
B.Act = False
P.Score = P.Score + 100
For C5 = 0 To 2
DoExplode B.x + Int(Rnd * 40), B.y + Int(Rnd * 30)
DoEvents
Next C5
End If
DoExplode PShot(C).x + 5, PShot(C).y + 7
PShot(C).Act = False
End If
End If
Next C
End If
End Sub

Public Sub DoExplode(x, y)
Dim C As Long
For C = 0 To 10
If Explo(C).Act = False Then
Explo(C).Act = True
Explo(C).x = x - 15
Explo(C).y = y - 15
Explo(C).Count = 0
Exit For
End If
Next C
End Sub

Public Sub DoAni()
Dim C As Long
For C = 0 To 10
If Explo(C).Act = True Then
Explo(C).Count = Explo(C).Count + 1
Explo(C).XF = Explo(C).Count * 30
If Explo(C).Count > 3 Then Explo(C).Act = False
End If
Next C
End Sub

Public Sub DoKeys()
If GetAsyncKeyState(vbKeyLeft) Then
P.TurnY = 32
P.Speed = P.Speed - 3: If P.Speed < -13 Then P.Speed = -13
ElseIf GetAsyncKeyState(vbKeyRight) Then
P.TurnY = 0
P.Speed = P.Speed + 3: If P.Speed > 13 Then P.Speed = 13
End If

If GetAsyncKeyState(vbKeySpace) Then Fire
End Sub

Public Sub MakeTank()
Dim C As Long
For C = 0 To 15
If T(C).Act = False Then
T(C).Act = True
T(C).y = FrmGame.Board.ScaleHeight - Int(Rnd * 10) - 20
If LEVEL > 2 Then
Select Case Int(Rnd * 2) + 1
Case 1
T(C).x = 2
T(C).Speed = 2
Case 2
T(C).x = FrmGame.Board.ScaleWidth
T(C).Speed = -2
End Select
Else
T(C).x = FrmGame.Board.ScaleWidth
T(C).Speed = -2
End If
Exit For
End If
Next C
End Sub

Sub CheckForBoss()
If P.Score > REQSCORE - 100 Then
If B.Act = False Then
B.x = 0
B.y = FrmGame.Board.ScaleHeight - 32
B.Damage = 0
B.Speed = 3
B.Act = True
End If
End If
End Sub

Sub BossFire()
Dim C As Long
For C = 0 To 10
If BShot(C).Act = False Then
BShot(C).x = B.x + 20
BShot(C).y = B.y
BShot(C).Damage = Int(Rnd * 20) + 1
BShot(C).Speed = Int(Rnd * 7) + 1
BShot(C).Act = True
Exit For
End If
Next C
End Sub

Sub BossAI()
If B.Act = True Then
If B.x > P.x - 30 And B.x < P.x + 30 Then
If Int(Rnd * 10) = 3 Then BossFire

For C2 = 0 To 20
If PShot(C).Act = True Then
If PShot(C).x > (B.x + 10) - 30 And PShot(C).x < (B.x + 10) + 30 And PShot(C).y > B.y - 30 Then
If PShot(C).x < (B.x + 10) Then B.Speed = 2
If PShot(C).x > (B.x + 10) Then B.Speed = -2
End If
End If
Next C2
End If

If Int(Rnd * 10) = 7 Then 'speed up
Select Case B.Speed
Case Is < 0
B.Speed = B.Speed - 1
Case Is > 0
B.Speed = B.Speed + 1
End Select
End If

If Int(Rnd * 10) = 3 Then 'slow down
Select Case B.Speed
Case Is < 0
B.Speed = B.Speed + 1
If B.Speed = 0 Then B.Speed = -1
Case Is > 0
B.Speed = B.Speed - 1
If B.Speed = 0 Then B.Speed = 1
End Select
End If

End If
End Sub

Function TakeScore(tScore As Long)
P.Score = P.Score - tScore: If P.Score < 0 Then P.Score = 0
End Function
